#!/bin/sh

#######################################################
# FileName:      10001_kboxTest.sh
# Description:   Kbox function of the service node.
# Return:         1: Black box is not turn on
#                 0: Black box is turn on
# Date:          2014-03-03
#######################################################
CHECK_ID=$(echo $(basename "$0") | awk -F "_" '{print $1}')
CHECK_DESC="Kbox function of the service node."
# import log function, $1 is log level default is 2, $2 is check item id
source /usr/libexec/osHealthCheck/modules/logger.sh 2 $$ $savefile

# Check kbox service file
if [ ! -f /usr/sbin/kbox ]; then
    g_LOG_Warn "/usr/sbin/kbox is missing, Check whether kbox is installed!"
    CHECK_INFO="The kbox function of the service node is disabled."
    g_LOG_Save_Result ${CHECK_ID} "${CHECK_DESC}" "Abnormal" "${CHECK_INFO}"
    exit ${ABNORMAL}
fi

# Check Black box status.
systemctl status kbox > /dev/null 2>&1
run=$?

if [ ${run} -ne 0 ]; then
    g_LOG_Warn "Kbox is not running,Check whether it is installed or started!"
    CHECK_INFO="The kbox function of the service node is disabled."
    g_LOG_Save_Result ${CHECK_ID} "${CHECK_DESC}" "Abnormal" "${CHECK_INFO}"
    exit ${ABNORMAL}
fi

CHECK_INFO="The kbox function of the service node is enabled."
g_LOG_Info "$CHECK_INFO"
g_LOG_Save_Result ${CHECK_ID} "${CHECK_DESC}" "OK" "${CHECK_INFO}"
exit ${NORMAL}
