#!/bin/sh

#######################################################
# FileName:      10004_cgroupTest.sh
# Description:   Check cgroup is turn on
# Return:         1: cgroup is not turn on
#                 0: cgroup is turn on
# Date:          2014-03-21
#######################################################
CHECK_ID=$(echo $(basename "$0") | awk -F "_" '{print $1}')
CHECK_DESC="Cgroup function of the service node."
# import log function, $1 is log level default is 2, $2 is check item id
source /usr/libexec/osHealthCheck/modules/logger.sh 2 $$ $savefile

CHECK_INFO="The cgroup function of the service node is abnormal."
# Check cgroup subsystems.
if [ ! -f "/sys/fs/cgroup/blkio/tasks" ]; then
    g_LOG_Warn "cgroup subsystem is not running normally: blkio partition is not mounted!"
    g_LOG_Save_Result ${CHECK_ID} "${CHECK_DESC}" "Abnormal" "${CHECK_INFO}"
    exit ${ABNORMAL}
elif [ ! -f "/sys/fs/cgroup/cpu,cpuacct/tasks" ]; then
    g_LOG_Warn "cgroup subsystem is not running normally: cpu,cpuacct partition is not mounted!"
    g_LOG_Save_Result ${CHECK_ID} "${CHECK_DESC}" "Abnormal" "${CHECK_INFO}"
    exit ${ABNORMAL}
elif [ ! -f "/sys/fs/cgroup/cpuset/tasks" ]; then
    g_LOG_Warn "cgroup subsystem is not running normally: cpuset partition is not mounted!"
    g_LOG_Save_Result ${CHECK_ID} "${CHECK_DESC}" "Abnormal" "${CHECK_INFO}"
    exit ${ABNORMAL}
elif [ ! -f "/sys/fs/cgroup/devices/tasks" ]; then
    g_LOG_Warn "cgroup subsystem is not running normally: devices partition is not mounted!"
    g_LOG_Save_Result ${CHECK_ID} "${CHECK_DESC}" "Abnormal" "${CHECK_INFO}"
    exit ${ABNORMAL}
elif [ ! -f "/sys/fs/cgroup/freezer/tasks" ]; then
    g_LOG_Warn "cgroup subsystem is not running normally: freezer partition is not mounted!"
    g_LOG_Save_Result ${CHECK_ID} "${CHECK_DESC}" "Abnormal" "${CHECK_INFO}"
    exit ${ABNORMAL}
elif [ ! -f "/sys/fs/cgroup/hugetlb/tasks" ]; then
    g_LOG_Warn "cgroup subsystem is not running normally: hugetlb partition is not mounted!"
    g_LOG_Save_Result ${CHECK_ID} "${CHECK_DESC}" "Abnormal" "${CHECK_INFO}"
    exit ${ABNORMAL}
elif [ ! -f "/sys/fs/cgroup/memory/tasks" ]; then
    g_LOG_Warn "cgroup subsystem is not running normally: memory partition is not mounted!"
    g_LOG_Save_Result ${CHECK_ID} "${CHECK_DESC}" "Abnormal" "${CHECK_INFO}"
    exit ${ABNORMAL}
elif [ ! -f "/sys/fs/cgroup/net_cls/tasks" ]; then
    g_LOG_Warn "cgroup subsystem is not running normally: net_cls partition is not mounted!"
    g_LOG_Save_Result ${CHECK_ID} "${CHECK_DESC}" "Abnormal" "${CHECK_INFO}"
    exit ${ABNORMAL}
elif [ ! -f "/sys/fs/cgroup/perf_event/tasks" ]; then
    g_LOG_Warn "cgroup subsystem is not running normally: perf_event partition is not mounted!"
    g_LOG_Save_Result ${CHECK_ID} "${CHECK_DESC}" "Abnormal" "${CHECK_INFO}"     
    exit ${ABNORMAL}
fi

CHECK_INFO="The cgroup function of the service node is normal."
g_LOG_Info "$CHECK_INFO"
g_LOG_Save_Result ${CHECK_ID} "${CHECK_DESC}" "OK" "${CHECK_INFO}"
exit ${NORMAL}
